<!DOCTYPE html>
<html>
<head>
<meta charset="ISO-8859-1">
<title>Twitter Messages By User Name</title>
<style>
.tweet {
  				border-radius: 3px;
                border: 1px solid #aaaaaa;
                padding: 3px;
                font-size: 14px;
}

#tweets {
  height: 450px;
  overflow: auto;
  background-color: lightblue;
}
tweetsDiv {
			height: 500px;
			width :700px;
			
  			

}
</style>
<script
	src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"></script>
</head>
<body>
	<form>
		<fieldset>
			<legend>Twitter Messages</legend>
			User Name : <input id="txtMessage" type="text"><br> <input
				onclick="doSendMessage();"   value="Display tweets for User"
				type="button">    <span id="connection"> </span> <br>
			<br><br>
			<div class="tweetsDiv" id ="tweets" ><legend>Tweets for You</legend>		
			</div>
			<ul id="hashUL">

			</ul>
			<input onclick="doCloseConnection();" value="Disconnect"
				type="button">
		</fieldset>
	</form>
	<script type="text/javascript">

		var webSocket = new WebSocket("ws://" + window.location.host + "/PersonalTweets/websocket");
		
		

		var msg_sum = 0;
		var hashMap = new Map();
		var userId = document.getElementById("txtMessage");

		webSocket.onopen = function(msgEvent) {
			document.getElementById("connection").innerText = "  Connected";
			document.getElementById("connection").style.color = "green";
		};
		
		webSocket.onmessage = function(msgEvent) {
			// hashmaps that handles hashtags sum relation
			msg_sum++;
			var hashtag = msgEvent.data
					.substring(0, msgEvent.data.indexOf(":"));
			var sum = hashMap.get(hashtag);
			if (sum)
				hashMap.set(hashtag, ++sum);
			else
				hashMap.set(hashtag, 1);
			// adds hashmap to UL 
			element = document.getElementById(hashtag);
			if (element) {
				element.innerHTML = '#'+ hashtag + " : " + sum + " Tweets ";
			} else {
				var node = document.createElement("LI");
				node.id = hashtag;
				var textnode = document.createTextNode(hashtag + ":" + sum + " Tweets ");
				node.appendChild(textnode);
				document.getElementById("hashUL").appendChild(node);
			}
			createTweetLine(msgEvent.data);
			
		};
		webSocket.onclose = function(msgEvent) {
			document.getElementById("connection").innerText = " Disconnected";
		};
		webSocket.onerror = function(msgEvent) {
			document.getElementById("connection").innerText = " Connection have Errors";
			document.getElementById("connection").style.color = "red";
		};

		/**
		 *  Send user id to WebSocket
		 */
		function doSendMessage() {
			webSocket.send(userId.value);
			document.getElementById("connection").innerText =  userId.value +"  Connected";
						
		}
		
		function createTweetLine(tweet)
		{
			var node = document.createElement("p");
			node.classList.add("tweet");
			var textnode = document.createTextNode(tweet);
			node.appendChild(textnode);
			document.getElementById("tweets").appendChild(node);
		}
		

		/**
		 *  Close Connection
		 */
		function doCloseConnection() {
			document.getElementById("connection").innerText = " Disconnected";
			document.getElementById("connection").style.color = "grey";
			webSocket.close();
		}
	</script>
</body>
</html>